#include "overlay.h"
#include <def21160.h>
#include <cdef21160.h>

asm("#include <def21160.h>");

extern UINT32 uOverlayId;
extern UINT32 uSymbolAddress;

void main(void)
{
	int flag1 = 0;
	int flag2 = 0;
	int flag3 = 0;

	/* Mem size 1024k, clock out disabled, buffer hang disabled */
	HW_Set_IOP(SYSCON, 0x0079c000);
	/* Mem type synchronous */
	HW_Set_IOP(WAIT, 0x00000005);

    /* Reset value */
    HW_Set_MODE1(0x00000000);

    /* Interrupt edge-sensitive */
    HW_Set_MODE2(0x00038005);

	// Reset ID
	asm volatile(".extern ov_id_loaded;"); 
	asm volatile("R0 = 0xFFFFFFFF;");
	asm volatile("dm(ov_id_loaded) = R0;");
	
	asm("bit set mode2 FLG1O | FLG2O | FLG0O;");
	asm("FLAGS = 0x7;");
	
	while(1)
	{
		flag1 = MAIN_Blink_LED1(flag1);
		flag2 = OVL1_Blink_LED2(flag2);
		flag3 = OVL2_Blink_LED3(flag3);	
	}
}

int MAIN_Blink_LED1(int flag1)
{
	int i;
	int j;
	
	for( i = 0; i < 10; i++ )
	{
		
		asm("FLAGS = 0x1;");
		
		for( j = 0; j < 0x5FFFF; j++ );
		
		asm("FLAGS = 0x0;");
		
		for( j = 0; j < 0x5FFFF; j++ );
	}
	
	return flag1;
}

